const fs = require("fs");
const path = require("path");
const matter = require("gray-matter");

function generateGlossaryMarkdown(glossary, termsDir, currentLocale) {
  let markdownContent = "";

  if (currentLocale == "fr") {
    markdownContent = `# Glossaire\n\n`;
    markdownContent += `Plongez dans les termes clés pertinents pour LINCS et Linked Open Data.\n\n`;
    markdownContent += "{/*ALL CONTENT ON THIS PAGE IS AUTOGENERATED */}\n\n";
  } else {
    markdownContent = `# Glossary\n\n`;
    markdownContent += `Dive into key terms relevant to LINCS and Linked Open Data.\n\n`;
    markdownContent += "{/*ALL CONTENT ON THIS PAGE IS AUTOGENERATED */}\n\n";
  }

  // Sort Glossary by title
  let sortedGlossary = Object.keys(glossary).map((key) => {
    return {
      id: key,
      ...glossary[key],
    };
  });

  sortedGlossary.sort((a, b) => a.title.localeCompare(b.title));

  // Generate markdown content
  for (const [key, value] of Object.entries(sortedGlossary)) {
    markdownContent += `## [${value.title}](${termsDir}/${value.id})\n\n`;
    markdownContent += `${value.definition} `;
  
    if (currentLocale == "fr") {
      markdownContent += `<a href="${termsDir}/${value.id}" title="En savoir plus sur ${value.title}" aria-label="En savoir plus sur ${value.title}">Lire plus...</a>\n\n`;
    } else {
      markdownContent += `<a href="${termsDir}/${value.id}" title="Learn more about ${value.title}" aria-label="Learn more about ${value.title}">Read more...</a>\n\n`;
    }
  }
  return markdownContent;
}

export function getDocsPluginConfig(presetsPlugins, pluginId) {
  // eslint-disable-next-line array-callback-return
  const filteredConfig = presetsPlugins.filter((data) => {
    // Search presets
    if (Array.isArray(data)) {
      if (typeof data[0] === "string" && data[0].endsWith(pluginId)) {
        return data[1];
      }

      // Search plugin-content-docs instances
      if (typeof data[0] === "string" && data[0] === "@docusaurus/plugin-content-docs") {
        const configPluginId = data[1].id ? data[1].id : "default";
        if (configPluginId === pluginId) {
          return data[1];
        }
      }
    }
  })[0];

  if (filteredConfig) {
    // Search presets, e.g. "classic"
    if (filteredConfig[0].endsWith(pluginId)) {
      return filteredConfig[1].docs;
    }

    // Search plugin-content-docs instances
    if (filteredConfig[0] === "@docusaurus/plugin-content-docs") {
      const configPluginId = filteredConfig[1].id ? filteredConfig[1].id : "default";
      if (configPluginId === pluginId) {
        return filteredConfig[1];
      }
    }
  }
  return;
}

export default function GlossaryPlugin(context, options) {
  const { config, docsPluginId } = options;
  const { siteDir, siteConfig } = context;
  const {
    i18n: { currentLocale },
  } = context;

  // Get routeBasePath and path from plugin-content-docs or preset
  const presets = siteConfig.presets;
  const plugins = siteConfig.plugins;
  const presetsPlugins = presets.concat(plugins);
  let docData = getDocsPluginConfig(presetsPlugins, docsPluginId);
  let docRouteBasePath = docData ? docData.routeBasePath : undefined;
  let docPath = docData ? (docData.path ? docData.path : "docs") : undefined;
  let i18nPath = null;

  // TODO: Replace with better translation handling
  if (currentLocale !== "en") {
    i18nPath = `${siteDir}/i18n/${currentLocale}/docusaurus-plugin-content-docs/current`;
  }

  async function generateGlossary(options, pluginId) {
    let { glossaryFilePath, termsDir, locale } = options;
    let glossary = {};
    // Override docPath if pluginId provided
    if (pluginId) {
      docData = getDocsPluginConfig(presetsPlugins, pluginId);
      docRouteBasePath = docData ? docData.routeBasePath : undefined;
      docPath = docData ? (docData.path ? docData.path : "docs") : undefined;
    }

    try {
      const glossaryPath = path.join(
        i18nPath ? i18nPath : siteDir,
        i18nPath ? termsDir.replace("docs/", "") : termsDir,
      );

      if (locale && locale !== currentLocale) {
        i18nPath = `${siteDir}/i18n/${locale}/docusaurus-plugin-content-docs/current`;
      }
      locale = locale || currentLocale;

      glossaryFilePath = i18nPath
        ? glossaryFilePath.replace("/docs", i18nPath)
        : path.join(siteDir, glossaryFilePath);

      const glossaryFiles = fs.readdirSync(glossaryPath);

      glossaryFiles.forEach((file) => {
        const filePath = path.join(glossaryPath, file);
        const fileContents = fs.readFileSync(filePath, "utf8");

        // creating term from frontmatter
        const { data } = matter(fileContents);

        if (data.id && data.definition) {
          glossary[data.id] = {
            title: data.title,
            definition: data.definition,
          };
        }
      });

      // Write the glossary to a markdown file
      const markdownContent = generateGlossaryMarkdown(glossary, termsDir, locale);
      fs.writeFileSync(glossaryFilePath, markdownContent);

      // Write the glossary to a JSON file
      const outputFilePath = path.join(context.siteDir, `static/glossary-${locale}.json`);
      fs.writeFileSync(outputFilePath, JSON.stringify(glossary, null, 2));
    } catch (e) {
      console.error(
        `Loading glossary files for markdown generation ${glossary}, ${termsDir}, ${locale}) failed: ${e}`,
      );
      console.error(
        `Loading glossary files (jsonfile: ${outputFilePath}, glossary: ${glossaryFilePath}) failed: ${e}`,
      );
      throw e;
    }
    return glossary;
  }

  return {
    name: "generate-glossary-plugin",
    async loadContent() {
      const glossary = generateGlossary(options, options.pluginId);
      return glossary;
    },

    async contentLoaded({ content, actions }) {
      generateGlossaryMarkdown(content);

      // Write to a temporary file (Docusaurus handles it)
      const { createData } = actions;
      await createData("static/glossary.json", JSON.stringify(content, null, 2));
    },

    extendCli(cli) {
      cli
        .command(`generate-glossary`)
        .description("Generate glossary markdown file")
        .action(() => {
          generateGlossary(options, options.pluginId);
        });
      cli
        .command(`generate-glossary.json [locale]`)
        .description("Generate glossary json file for specific locale (default: en)")
        .action((locale) => {
          options.locale = locale ? locale : "en";
          generateGlossary(options, options.pluginId);
        });
    },
  };
}
